// Dynamic link library implementation of NeuroSolutions Function component for SquareWave setting

#include "NSDLL.h" 

/***************************/
/* Activation of component */
__declspec(dllexport) NSFloat performFunction(
	DLLData	*instance,	// Pointer to instance data (may be NULL)
	NSFloat	x 		// Current argument in radians
	)
{
	NSFloat width = getFloatParameter(instance, 2, 1);
	return x<width? 1.0f: 0;
}

/******************************************/
/* Management of instance data (OPTIONAL) */
__declspec(dllexport) DLLData *allocFunction(
	DLLData	*oldInstance	// Pointer to the last instance if reallocating
	)
{
	DLLData *instance = allocDLLInstance(oldInstance);
	setParameterName(instance, 2, 1, "Width", FALSE);
	setFloatParameter(instance, 2, 1, 0.1f, FALSE);
	return instance;
}

__declspec(dllexport) void freeFunction(DLLData *instance)
{
	freeDLLInstance(instance);
}
